﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Reflection;

namespace Builder
{
    public partial class MainWindow : Form
    {
        public MainWindow()
        {
            InitializeComponent();

            treeView.AllowDrop = true;

            addComponent (typeof (Record));
            addComponent (typeof (Field));

            /*
            Type t = typeof(Button);
            foreach (MethodInfo m in t.GetMethods())
                textBox1.AppendText(m.Name + "\n");
            */
        }

        private void addComponent(Type type)
        {
            Component c = new Component (type);

            int n = componentPage.Controls.Count;
            c.Left = c.Left + n * (c.Width + c.Left);
            componentPage.Controls.Add(c);
        }

        private void quitMenuItem_Click(object sender, EventArgs e)
        {
            Close();
        }

        private void treeView_DragEnter(object sender, DragEventArgs e)
        {
            if (e.Data.GetDataPresent ("Builder.Component"))
               e.Effect = DragDropEffects.Copy;
        }

        private void treeView_DragDrop(object sender, DragEventArgs e)
        {
            if (e.Data.GetDataPresent("Builder.Component"))
            {
                Component c = e.Data.GetData("Builder.Component") as Component;
                Object obj = c.CreateInstance();

                TreeNode node = new TreeNode();
                node.Text = obj.ToString();
                node.Tag = obj;

                if (obj is Common)
                {
                    Common p = obj as Common;
                    p.setup (node, stage);
                }
                else
                {
                    node.BackColor = c.BackColor;
                }

                Point pt = treeView.PointToClient(new Point(e.X, e.Y));
                TreeNode target = treeView.GetNodeAt(pt);
                if (target != null)
                    target.Nodes.Add(node);
                    // target.Nodes.Insert(0, node);
                else
                    treeView.Nodes.Add(node);
            }

        }

        private void treeView_NodeMouseClick(object sender, TreeNodeMouseClickEventArgs e)
        {
            Object obj = e.Node.Tag;
            propertyGrid.SelectedObject = obj;
        }
    }
}
